Index: palm/trunk/SOURCE/poisfft_hybrid.f90
===================================================================
--- palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1105)
+++ palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions: 
 ! ----------------- 
-!
+! calls of fft_x, fft_y replaced by fft_x_1d, fft_y_1d
 !
 ! Former revisions: 
@@ -334,5 +334,5 @@
        CALL cpu_log( log_point_s(30), 'poisfft_hybrid_omp', 'start' )
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'start' )
 
 !$OMP  PARALLEL PRIVATE (i,iouter,ii,ir,iei,j,k,m,n,ffty_ar)
@@ -353,5 +353,5 @@
                 ENDDO
    
-                CALL fft_y( ffty_ar(:,ir), 'forward' )
+                CALL fft_y_1d( ffty_ar(:,ir), 'forward' )
              ENDDO
 
@@ -371,5 +371,5 @@
 !$OMP  END PARALLEL
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'pause' )
 
 #if defined( __parallel )
@@ -385,5 +385,5 @@
 #endif
 
-       CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'start' )
+       CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'start' )
 
 #if defined( __KKMP )
@@ -406,5 +406,5 @@
              ENDDO
 
-             CALL fft_x( fftx_ar, 'forward' )
+             CALL fft_x_1d( fftx_ar, 'forward' )
 
              DO  i = nxl_a, nxr_a
@@ -422,5 +422,5 @@
              ENDDO
 
-             CALL fft_x( fftx_ar, 'backward' )
+             CALL fft_x_1d( fftx_ar, 'backward' )
 
              m = nxl_a
@@ -438,5 +438,5 @@
 #endif
 
-       CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'stop' )
+       CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'stop' )
 
 #if defined( __parallel )
@@ -453,5 +453,5 @@
 #endif
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'continue' )
 
 !$OMP  PARALLEL PRIVATE (i,iouter,ii,ir,iei,j,k,m,n,ffty_ar)
@@ -475,5 +475,5 @@
                 ii = nxl + i
                 ir = i - iouter + 1
-                CALL fft_y( ffty_ar(:,ir), 'backward' )
+                CALL fft_y_1d( ffty_ar(:,ir), 'backward' )
 
                 DO  j = nys_a, nyn_a
@@ -486,5 +486,5 @@
 !$OMP  END PARALLEL
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'stop' )
 
        CALL cpu_log( log_point_s(30), 'poisfft_hybrid_omp', 'stop' )
@@ -702,5 +702,5 @@
        CALL cpu_log( log_point_s(30), 'poisfft_hybrid_nodes', 'start' )
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'start' )
 
 !
@@ -719,5 +719,5 @@
                 ENDDO
    
-                CALL fft_y( ffty_ar(:,ir), 'forward' )
+                CALL fft_y_1d( ffty_ar(:,ir), 'forward' )
              ENDDO
 
@@ -738,5 +738,5 @@
        ENDDO
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'pause' )
 
        CALL cpu_log( log_point_s(32), 'alltoall_task', 'start' )
@@ -767,5 +767,5 @@
           CALL cascade( 2, j, nys_p, nyn_p )
 
-          CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'start' )
+          CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'start' )
           DO  k = 1, nz
 
@@ -780,5 +780,5 @@
              ENDDO
 
-             CALL fft_x( fftx_ar, 'forward' )
+             CALL fft_x_1d( fftx_ar, 'forward' )
 
              DO  i = nxl_a, nxr_a
@@ -796,5 +796,5 @@
              ENDDO
 
-             CALL fft_x( fftx_ar, 'backward' )
+             CALL fft_x_1d( fftx_ar, 'backward' )
 
              m = nxl_a
@@ -809,5 +809,5 @@
           ENDDO
 
-          CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'stop' )
+          CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'stop' )
           nw2 = nw1 * SIZE( work1, 3 )
           CALL cpu_log( log_point_s(37), 'alltoall_node', 'continue' )
@@ -833,5 +833,5 @@
        CALL cpu_log( log_point_s(32), 'alltoall_task', 'stop' )
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'continue' )
 
        DO  iouter = nxl_p, nxr_p, istride
@@ -855,5 +855,5 @@
                 ii = nxl + i
                 ir = i - iouter + 1
-                CALL fft_y( ffty_ar(:,ir), 'backward' )
+                CALL fft_y_1d( ffty_ar(:,ir), 'backward' )
 
                 DO  j = nys_a, nyn_a
@@ -865,5 +865,5 @@
        ENDDO
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'stop' )
 
        CALL cpu_log( log_point_s(30), 'poisfft_hybrid_nodes', 'stop' )
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1105)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! small changes in code formatting
 !
 ! Former revisions:
@@ -418,29 +418,28 @@
 
 !
-!--      If required, calculate tendencies for total water content, rain water 
-!--      content, rain drop concentration and liquid temperature
-
-         IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
-
-            tend_q(:,j,i)  = 0.0
-            tend_qr(:,j,i) = 0.0
-            tend_nr(:,j,i) = 0.0
-            tend_pt(:,j,i) = 0.0
-!
-!--         Droplet size distribution (dsd) properties are needed for the 
-!--         computation of selfcollection, breakup, evaporation and 
-!--         sedimentation of rain.  
-            IF ( precipitation )  THEN
-               CALL dsd_properties( i,j ) 
-               CALL autoconversion( i,j )
-               CALL accretion( i,j )
-               CALL selfcollection_breakup( i,j )
-               CALL evaporation_rain( i,j )
-               CALL sedimentation_rain( i,j )
-            ENDIF
-
-            IF ( drizzle )  CALL sedimentation_cloud( i,j )
-
-         ENDIF
+!--       If required, calculate tendencies for total water content, rain water 
+!--       content, rain drop concentration and liquid temperature
+          IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+
+             tend_q(:,j,i)  = 0.0
+             tend_qr(:,j,i) = 0.0
+             tend_nr(:,j,i) = 0.0
+             tend_pt(:,j,i) = 0.0
+!
+!--          Droplet size distribution (dsd) properties are needed for the
+!--          computation of selfcollection, breakup, evaporation and
+!--          sedimentation of rain
+             IF ( precipitation )  THEN
+                CALL dsd_properties( i,j )
+                CALL autoconversion( i,j )
+                CALL accretion( i,j )
+                CALL selfcollection_breakup( i,j )
+                CALL evaporation_rain( i,j )
+                CALL sedimentation_rain( i,j )
+             ENDIF
+
+             IF ( drizzle )  CALL sedimentation_cloud( i,j )
+
+          ENDIF
 
 !
@@ -469,9 +468,10 @@
              ENDIF
 
+!
 !--          Using microphysical tendencies (latent heat)
              IF ( cloud_physics )  THEN
                 IF ( icloud_scheme == 0 )  THEN
                    tend(:,j,i) = tend(:,j,i) + tend_pt(:,j,i)
-                ELSEIF ( icloud_scheme == 1 .AND. precipitation)  THEN
+                ELSEIF ( icloud_scheme == 1  .AND.  precipitation )  THEN
                    CALL impact_of_latent_heat( i, j ) 
                 ENDIF
@@ -480,14 +480,13 @@
 !
 !--          Consideration of heat sources within the plant canopy
-             IF ( plant_canopy .AND. ( cthf /= 0.0 ) ) THEN
+             IF ( plant_canopy  .AND.  cthf /= 0.0 )  THEN
                 CALL plant_canopy_model( i, j, 4 )
              ENDIF
 
 !
-!--          If required, compute influence of large-scale subsidence/ascent
+!--          If required, compute effect of large-scale subsidence/ascent
              IF ( large_scale_subsidence )  THEN
                 CALL subsidence( i, j, tend, pt, pt_init )
              ENDIF
-
 
              CALL user_actions( i, j, 'pt-tendency' )
@@ -600,5 +599,5 @@
                 IF ( icloud_scheme == 0 )  THEN
                    tend(:,j,i) = tend(:,j,i) + tend_q(:,j,i)
-                ELSEIF ( icloud_scheme == 1 .AND. precipitation )  THEN
+                ELSEIF ( icloud_scheme == 1  .AND.  precipitation )  THEN
                    CALL calc_precipitation( i, j )
                 ENDIF
@@ -606,5 +605,5 @@
 !
 !--          Sink or source of scalar concentration due to canopy elements
-             IF ( plant_canopy ) CALL plant_canopy_model( i, j, 5 )
+             IF ( plant_canopy )  CALL plant_canopy_model( i, j, 5 )
 
 !
@@ -645,5 +644,5 @@
 !--          If required, calculate prognostic equations for rain water content 
 !--          and rain drop concentration
-             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
 !
 !--             Calculate prognostic equation for rain water content
@@ -706,7 +705,7 @@
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
-                      CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,    & 
-                                    diss_s_nr, flux_l_nr, diss_l_nr, &
-                                    i_omp_start, tn )
+                      CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,       & 
+                                       diss_s_nr, flux_l_nr, diss_l_nr, &
+                                       i_omp_start, tn )
                    ELSE 
                       CALL advec_s_pw( i, j, nr )
Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 1105)
+++ palm/trunk/SOURCE/transpose.f90	(revision 1106)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! preprocessor lines rearranged so that routines can also be used in serial
+! (non-parallel) mode
 !
 ! Former revisions:
@@ -84,6 +85,4 @@
              work(nnx*nny*nnz)
 
-#if defined( __parallel )
-
 !
 !-- Rearrange indices of input array in order to make data to be send
@@ -100,33 +99,52 @@
 !$OMP  END PARALLEL
 
-!
-!-- Transpose array
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLTOALL( f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
-                       work(1),              sendrecvcount_xy, MPI_REAL, &
-                       comm1dy, ierr )
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!-- Reorder transposed array
+    IF ( numprocs /= 1 )  THEN
+
+#if defined( __parallel )
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLTOALL( f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
+                          work(1),              sendrecvcount_xy, MPI_REAL, &
+                          comm1dy, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!--    Reorder transposed array
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, m, ys )
 !$OMP  DO
-    DO  l = 0, pdims(2) - 1
-       m  = l * ( nxr_y - nxl_y + 1 ) * ( nzt_y - nzb_y + 1 ) * &
-                ( nyn_x - nys_x + 1 )
-       ys = 0 + l * ( nyn_x - nys_x + 1 )
-       DO  i = nxl_y, nxr_y
-          DO  k = nzb_y, nzt_y
-             DO  j = ys, ys + nyn_x - nys_x
-                m = m + 1
-                f_out(j,i,k) = work(m)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDDO
-!$OMP  END PARALLEL
-
+       DO  l = 0, pdims(2) - 1
+          m  = l * ( nxr_y - nxl_y + 1 ) * ( nzt_y - nzb_y + 1 ) * &
+                   ( nyn_x - nys_x + 1 )
+          ys = 0 + l * ( nyn_x - nys_x + 1 )
+          DO  i = nxl_y, nxr_y
+             DO  k = nzb_y, nzt_y
+                DO  j = ys, ys + nyn_x - nys_x
+                   m = m + 1
+                   f_out(j,i,k) = work(m)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
 #endif
+
+    ELSE
+
+!
+!--    Reorder transposed array
+!$OMP  PARALLEL PRIVATE ( i, j, k )
+!$OMP  DO
+       DO  k = nzb_y, nzt_y
+          DO  i = nxl_y, nxr_y
+             DO  j = 0, ny
+                f_out(j,i,k) = f_inv(j,k,i)
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
+
+    ENDIF
 
  END SUBROUTINE transpose_xy
@@ -158,5 +176,4 @@
              work(nnx*nny*nnz)
 
-#if defined( __parallel )
 
 !
@@ -164,4 +181,6 @@
 !-- reordered locally and therefore no transposition has to be done.
     IF ( pdims(1) /= 1 )  THEN
+
+#if defined( __parallel )
 !
 !--    Reorder input array for transposition
@@ -203,5 +222,8 @@
        ENDDO
 !$OMP  END PARALLEL
+#endif
+
     ELSE
+
 !
 !--    Reorder the array in a way that the z index is in first position
@@ -229,7 +251,4 @@
 
     ENDIF
-
-
-#endif
 
  END SUBROUTINE transpose_xz
@@ -261,33 +280,52 @@
              work(nnx*nny*nnz)
 
+    IF ( numprocs /= 1 )  THEN
+
 #if defined( __parallel )
-
-!
-!-- Reorder input array for transposition
+!
+!--    Reorder input array for transposition
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, m, ys )
 !$OMP  DO
-    DO  l = 0, pdims(2) - 1
-       m  = l * ( nxr_y - nxl_y + 1 ) * ( nzt_y - nzb_y + 1 ) * &
-                ( nyn_x - nys_x + 1 )
-       ys = 0 + l * ( nyn_x - nys_x + 1 )
+       DO  l = 0, pdims(2) - 1
+          m  = l * ( nxr_y - nxl_y + 1 ) * ( nzt_y - nzb_y + 1 ) * &
+                   ( nyn_x - nys_x + 1 )
+          ys = 0 + l * ( nyn_x - nys_x + 1 )
+          DO  i = nxl_y, nxr_y
+             DO  k = nzb_y, nzt_y
+                DO  j = ys, ys + nyn_x - nys_x
+                   m = m + 1
+                   work(m) = f_in(j,i,k)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
+
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLTOALL( work(1),              sendrecvcount_xy, MPI_REAL, &
+                          f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
+                          comm1dy, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+#endif
+
+    ELSE
+
+!
+!--    Reorder array f_in the same way as ALLTOALL did it
+!$OMP  PARALLEL PRIVATE ( i, j, k )
+!$OMP  DO
        DO  i = nxl_y, nxr_y
           DO  k = nzb_y, nzt_y
-             DO  j = ys, ys + nyn_x - nys_x
-                m = m + 1
-                work(m) = f_in(j,i,k)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDDO
-!$OMP  END PARALLEL
-
-!
-!-- Transpose array
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLTOALL( work(1),              sendrecvcount_xy, MPI_REAL, &
-                       f_inv(nys_x,nzb_x,0), sendrecvcount_xy, MPI_REAL, &
-                       comm1dy, ierr )
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+             DO  j = 0, ny
+                f_inv(j,k,i) = f_in(j,i,k)
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
+
+    ENDIF
 
 !
@@ -303,6 +341,4 @@
     ENDDO
 !$OMP  END PARALLEL
-
-#endif
 
  END SUBROUTINE transpose_yx
@@ -402,6 +438,4 @@
              work(nnx*nny*nnz)
 
-#if defined( __parallel )
-
 !
 !-- Rearrange indices of input array in order to make data to be send
@@ -424,4 +458,5 @@
 !-- of the data is necessary and no transposition has to be done.
     IF ( pdims(1) == 1 )  THEN
+
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
@@ -434,36 +469,38 @@
        ENDDO
 !$OMP  END PARALLEL
-       RETURN
-    ENDIF
-
-!
-!-- Transpose array
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLTOALL( f_inv(nxl_y,nzb_y,0), sendrecvcount_yz, MPI_REAL, &
-                       work(1),              sendrecvcount_yz, MPI_REAL, &
-                       comm1dx, ierr )
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!-- Reorder transposed array
+
+    ELSE
+
+#if defined( __parallel )
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLTOALL( f_inv(nxl_y,nzb_y,0), sendrecvcount_yz, MPI_REAL, &
+                          work(1),              sendrecvcount_yz, MPI_REAL, &
+                          comm1dx, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!--    Reorder transposed array
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, m, zs )
 !$OMP  DO
-    DO  l = 0, pdims(1) - 1
-       m  = l * ( nyn_z - nys_z + 1 ) * ( nzt_y - nzb_y + 1 ) * &
-                ( nxr_z - nxl_z + 1 )
-       zs = 1 + l * ( nzt_y - nzb_y + 1 )
-       DO  j = nys_z, nyn_z
-          DO  k = zs, zs + nzt_y - nzb_y
-             DO  i = nxl_z, nxr_z
-                m = m + 1
-                f_out(i,j,k) = work(m)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDDO
-!$OMP  END PARALLEL
-
+       DO  l = 0, pdims(1) - 1
+          m  = l * ( nyn_z - nys_z + 1 ) * ( nzt_y - nzb_y + 1 ) * &
+                   ( nxr_z - nxl_z + 1 )
+          zs = 1 + l * ( nzt_y - nzb_y + 1 )
+          DO  j = nys_z, nyn_z
+             DO  k = zs, zs + nzt_y - nzb_y
+                DO  i = nxl_z, nxr_z
+                   m = m + 1
+                   f_out(i,j,k) = work(m)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
 #endif
+
+   ENDIF
 
  END SUBROUTINE transpose_yz
@@ -490,9 +527,10 @@
     INTEGER ::  i, j, k, l, m, xs
     
-    REAL ::  f_in(1:nz,nys:nyn,nxl:nxr), f_inv(nys:nyn,nxl:nxr,1:nz), &
-             f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x),                     &
+    REAL ::  f_in(1:nz,nys:nyn,nxl:nxr), f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x), &
              work(nnx*nny*nnz)
 
-#if defined( __parallel )
+    !$acc declare create ( f_inv )
+    REAL ::  f_inv(nys:nyn,nxl:nxr,1:nz)
+
 
 !
@@ -501,6 +539,9 @@
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
+    !$acc kernels present( f_in )
+    !$acc loop
     DO  k = 1,nz
        DO  i = nxl, nxr
+          !$acc loop vector( 32 )
           DO  j = nys, nyn
              f_inv(j,i,k) = f_in(k,j,i)
@@ -516,8 +557,12 @@
 !-- of the data is necessary and no transposition has to be done.
     IF ( pdims(1) == 1 )  THEN
-!$OMP  PARALLEL PRIVATE ( i, j, k )
-!$OMP  DO
+
+!$OMP  PARALLEL PRIVATE ( i, j, k )
+!$OMP  DO
+       !$acc kernels present( f_out )
+       !$acc loop
        DO  k = 1, nz
           DO  i = nxl, nxr
+             !$acc loop vector( 32 )
              DO  j = nys, nyn
                 f_out(i,j,k) = f_inv(j,i,k)
@@ -526,35 +571,37 @@
        ENDDO
 !$OMP  END PARALLEL
-       RETURN
+
+    ELSE
+
+#if defined( __parallel )
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLTOALL( f_inv(nys,nxl,1), sendrecvcount_zx, MPI_REAL, &
+                          work(1),          sendrecvcount_zx, MPI_REAL, &
+                          comm1dx, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!--    Reorder transposed array
+!$OMP  PARALLEL PRIVATE ( i, j, k, l, m, xs )
+!$OMP  DO
+       DO  l = 0, pdims(1) - 1
+          m  = l * ( nzt_x - nzb_x + 1 ) * nnx * ( nyn_x - nys_x + 1 )
+          xs = 0 + l * nnx
+          DO  k = nzb_x, nzt_x
+             DO  i = xs, xs + nnx - 1
+                DO  j = nys_x, nyn_x
+                   m = m + 1
+                   f_out(i,j,k) = work(m)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+!$OMP  END PARALLEL
+#endif
+
     ENDIF
-
-!
-!-- Transpose array
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLTOALL( f_inv(nys,nxl,1), sendrecvcount_zx, MPI_REAL, &
-                       work(1),          sendrecvcount_zx, MPI_REAL, &
-                       comm1dx, ierr )
-    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!-- Reorder transposed array
-!$OMP  PARALLEL PRIVATE ( i, j, k, l, m, xs )
-!$OMP  DO
-    DO  l = 0, pdims(1) - 1
-       m  = l * ( nzt_x - nzb_x + 1 ) * nnx * ( nyn_x - nys_x + 1 )
-       xs = 0 + l * nnx
-       DO  k = nzb_x, nzt_x
-          DO  i = xs, xs + nnx - 1
-             DO  j = nys_x, nyn_x
-                m = m + 1
-                f_out(i,j,k) = work(m)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDDO
-!$OMP  END PARALLEL
-
-#endif
 
  END SUBROUTINE transpose_zx
@@ -586,10 +633,10 @@
              work(nnx*nny*nnz)
 
-#if defined( __parallel )
-
 !
 !-- If the PE grid is one-dimensional along y, the array has only to be
 !-- reordered locally and therefore no transposition has to be done.
     IF ( pdims(1) /= 1 )  THEN
+
+#if defined( __parallel )
 !
 !--    Reorder input array for transposition
@@ -619,20 +666,9 @@
                           comm1dx, ierr )
        CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!--    Reorder transposed array in a way that the y index is in first position
-!$OMP  PARALLEL PRIVATE ( i, j, k )
-!$OMP  DO
-       DO  j = 0, ny
-          DO  k = nzb_y, nzt_y
-             DO  i = nxl_y, nxr_y
-                f_out(j,i,k) = f_inv(i,k,j)
-             ENDDO
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
+#endif
+
     ELSE
 !
-!--    Reorder the array in a way that the y index is in first position
+!--    Reorder the array in the same way like ALLTOALL did it
 !$OMP  PARALLEL PRIVATE ( i, j, k )
 !$OMP  DO
@@ -645,20 +681,19 @@
        ENDDO
 !$OMP  END PARALLEL
-!
-!--    Move data to output array
-!$OMP  PARALLEL PRIVATE ( i, j, k )
-!$OMP  DO
-       DO  k = nzb_y, nzt_y
-          DO  i = nxl_y, nxr_y
-             DO  j = 0, ny
-                f_out(j,i,k) = f_inv(i,k,j)
-             ENDDO
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
 
     ENDIF
 
-#endif
+!
+!-- Reorder transposed array in a way that the y index is in first position
+!$OMP  PARALLEL PRIVATE ( i, j, k )
+!$OMP  DO
+    DO  k = nzb_y, nzt_y
+       DO  i = nxl_y, nxr_y
+          DO  j = 0, ny
+             f_out(j,i,k) = f_inv(i,k,j)
+          ENDDO
+       ENDDO
+    ENDDO
+!$OMP  END PARALLEL
 
  END SUBROUTINE transpose_zy
Index: palm/trunk/SOURCE/user_data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/user_data_output_3d.f90	(revision 1105)
+++ palm/trunk/SOURCE/user_data_output_3d.f90	(revision 1106)
@@ -19,5 +19,6 @@
 !
 ! Current revisions:
-! -----------------
+! ------------------
+! array_kind renamed precision_kind
 !
 ! Former revisions:
@@ -40,6 +41,6 @@
 !------------------------------------------------------------------------------!
 
-    USE array_kind
     USE indices
+    USE precision_kind
     USE user
 
